import java.util.ArrayList;

class Jugador{
    /////////////////////////////// Parameters
    // El aproach es que cada jugador tiene casillas, y cada casilla tiene una pieza
    private ArrayList<Casilla> casillas = new ArrayList<Casilla>(); 
    private int jugadorN; 

    /////////////////////////////// Inicializators
    public Jugador(int N){
        this.jugadorN = N;
    }
    /////////////////////////////// Methods
    public void addCasilla(Casilla casilla){
        this.casillas.add(casilla);
    }
    public void removeCasilla(Casilla casillaEliminar){
        int n = 100;
        for (int i=0; i<this.casillas.size();i++){
            Casilla casilla = casillas.get(i);
            if (casillaEliminar.equals(casilla)){
                n = i;
            }
        }
        if (n < 100){
            casillas.remove(n);
        }
    }
    public void deleteCasillas(){
        casillas = new ArrayList<Casilla>(); 
    }
    public void changeCasilla(Casilla casilla){
        this.casillas.add(casilla);
    }
    public ArrayList<Casilla> getCasillas(){
        return this.casillas;
    }
    public int getN(){
        return this.jugadorN;
    }
    public int[] traducirMovimiento(String instruccion, Tablero tablero){
        if (instruccion.length() != 7){
            return new int[] {-1,-1,-1,-1};
        }
        int columna = (int) instruccion.charAt(0)-(int) 'A';
        int fila = (int) instruccion.charAt(1)-(int) '1';
        int columnaObjetivo = (int) instruccion.charAt(5)-(int) 'A';
        int filaObjetivo = (int) instruccion.charAt(6)-(int) '1'; 
        if (this.jugadorN == 2){
            columna = 7-columna;
            fila = 7-fila;
            columnaObjetivo = 7-columnaObjetivo;
            filaObjetivo = 7-filaObjetivo; 
        }
        //if ((columna <= 0 && columna < 8) && (columnaObjetivo <= 0 && columnaObjetivo < 8) && (fila <= 0 && fila < 8) && (filaObjetivo <= 0 && filaObjetivo < 8)){
        return new int[] {columna, fila, columnaObjetivo, filaObjetivo};
    }

    public boolean checkEstoyEnJaque(Jugador oponente, Tablero tablero){
        Casilla rey=new Casilla(0, 0);
        boolean jaque = false;
        for (Casilla casilla: this.casillas){
            if (casilla.getPieza().equals(this)){
                rey = casilla;
            }
        }
        ArrayList<Casilla> casillasOponente = oponente.getCasillas();
        for (Casilla casillaOponente: casillasOponente){
            Pieza piezaOponente = casillaOponente.getPieza(); 
            if (piezaOponente instanceof Alfil){ 
                if (((Alfil) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Caballo){ 
                if (((Caballo) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Torre){ 
                if (((Torre) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Peon){ 
                if (((Peon) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Quina){ 
                if (((Quina) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Rey){ 
                if (((Rey) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Torre){ 
                if (((Torre) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
        }
        return jaque;
    }
    public boolean checkEstoyEnJaque(Jugador oponente, Tablero tablero, int i, int j){
        Casilla rey=new Casilla(i, j);
        ArrayList<Casilla> casillasOponente = oponente.getCasillas();
        for (Casilla casillaOponente: casillasOponente){
            Pieza piezaOponente = casillaOponente.getPieza(); 
            if (piezaOponente instanceof Alfil){ 
                if (((Alfil) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Caballo){ 
                if (((Caballo) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Torre){ 
                if (((Torre) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Peon){ 
                if (((Peon) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Quina){ 
                if (((Quina) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Rey){ 
                if (((Rey) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
            if (piezaOponente instanceof Torre){ 
                if (((Torre) piezaOponente).validarMovimiento(casillaOponente, rey, tablero)){
                    return true;
                } 
            } 
        }
        return false;
    }
    public boolean checkEsJaqueMate(Jugador oponente, Tablero tablero){
        Casilla rey=new Casilla(0, 0);
        boolean mate = false;
        for (Casilla casilla: this.casillas){
            if (casilla.getPieza().getNombre().equals("Rey")){
                rey = casilla;
            }
        }
        ArrayList<Casilla> casillasOponente = oponente.getCasillas();
        for (int i=rey.getX()-1; i<rey.getX()+2; i++){  
            for (int j=rey.getY()-1; j<rey.getY()+2; j++){
                for (Casilla casillaOponente: casillasOponente){
                    Pieza piezaOponente = casillaOponente.getPieza(); 
                    if (piezaOponente instanceof Alfil){ 
                        if (((Alfil) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i,j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Caballo){ 
                        if (((Caballo) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Torre){ 
                        if (((Torre) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Peon){ 
                        if (((Peon) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Quina){ 
                        if (((Quina) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Rey){ 
                        if (((Rey) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        } 
                    } 
                    if (piezaOponente instanceof Torre){ 
                        if (((Torre) piezaOponente).validarMovimiento(casillaOponente, new Casilla(i, j, new Rey(this)), tablero)){
                            mate = true;
                        }
                    }
                } 
            } 
        }
        return mate;
    }
}

